<!DOCTYPE html(lang='en')>
<html>
<head>
	<meta charset="UTF-8">
	<title>Task Factory</title>
	<script src="https://use.fontawesome.com/3ffec61ef7.js"></script>
	<!-- Bootstrap -->
	
	<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">
	
	<!-- <link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/css/esri.css"> -->
	<link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/themes/calcite/dijit/calcite.css">
	<link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/themes/calcite/esri/esri.css">
	<script src="https://js.arcgis.com/3.20/"></script>

	
	
	
	<script src="localDependency.js"></script>
	
	<style type="text/css">
	#info {
			top: 20px;
			color: #444;
			height: auto;
			font-family: arial;
			right: 20px;
			margin: 5px;
			padding: 10px;
			position: absolute;
			width: auto;
			z-index: 40;
			border: solid 2px #666;
			border-radius: 4px;
			background-color: #fff;
		  }
		  html, body, #mapDiv {
			padding:0;
			margin:0;
			height:90%;
		  }
		  button {
			display: block;
		  }
	</style>
	
	<script type="text/javascript">
	
	$( document ).ready(function() {
	
		$('#info').hide();
		$('#instructionCircle').hide();
		$('#instructionPoligon').hide();
	
		var map, tb;
			var area_list= [];
			var area_list_WebMercator = [];
			var graphic;
			
			$('#geo').change(function() {
				$('#info').toggle();
				$('#deleteall').click();
				$('#instructionCircle').toggle();
				$('#instructionPoligon').toggle();				
			});	

			require([
			  "esri/map", "esri/toolbars/draw", "esri/symbols/SimpleFillSymbol", "esri/geometry/Point",
			  "esri/symbols/SimpleMarkerSymbol", "esri/symbols/SimpleLineSymbol",
			  "esri/symbols/PictureFillSymbol", "esri/symbols/CartographicLineSymbol", 
			  "esri/graphic", "esri/geometry/webMercatorUtils",
			  "esri/Color", "dojo/dom", "dojo/on", "dojo/domReady!", "esri/dijit/Search"
			], function(
			  Map, Draw,SimpleFillSymbol, Point,
			  SimpleMarkerSymbol, SimpleLineSymbol,
			  PictureFillSymbol, CartographicLineSymbol, 
			  Graphic, webMercatorUtils,
			  Color, dom, on, Search
			) {
			  map = new Map("mapDiv", {
				basemap: "streets",
				center: [11.589322, 50.928229],
				zoom: 13
			  });
			  map.on("load", initToolbar);		  
			  

			  // markerSymbol is used for point and multipoint, see http://raphaeljs.com/icons/#talkq for more examples
			  var markerSymbol = new SimpleMarkerSymbol();
			  markerSymbol.setPath("M16,4.938c-7.732,0-14,4.701-14,10.5c0,1.981,0.741,3.833,2.016,5.414L2,25.272l5.613-1.44c2.339,1.316,5.237,2.106,8.387,2.106c7.732,0,14-4.701,14-10.5S23.732,4.938,16,4.938zM16.868,21.375h-1.969v-1.889h1.969V21.375zM16.772,18.094h-1.777l-0.176-8.083h2.113L16.772,18.094z");
			  markerSymbol.setColor(new Color("#00FFFF"));

			  // lineSymbol used for freehand polyline, polyline and line. 
			  var lineSymbol = new CartographicLineSymbol(
				CartographicLineSymbol.STYLE_SOLID,
				new Color([255,0,0]), 10, 
				CartographicLineSymbol.CAP_ROUND,
				CartographicLineSymbol.JOIN_MITER, 5
			  );

			  // fill symbol used for extent, polygon and freehand polygon, use a picture fill symbol
			  // the images folder contains additional fill images, other options: sand.png, swamp.png or stiple.png
			  var fillSymbol = new SimpleFillSymbol();

			  function initToolbar() {
			  
				tb = new Draw(map);	
				tb.on("draw-end", addGraphic);    

				// event delegation so a click handler is not
				// needed for each individual button
				on(dom.byId("info"), "click", function(evt) {
				  if ( evt.target.id === "info" || evt.target.id.includes('sentence') ) {
					return;
				  }
				  
				  if ( evt.target.id === "deleteall" ) {
					  map.graphics.clear();
					  for (var i = area_list.length;             i > 0; i--) {   area_list.pop();  }
					  for (var j = area_list_WebMercator.length; j > 0; j--) {   area_list_WebMercator.pop();   }   
					  console.log('Size of area array is ' + area_list.length);
					  console.log( JSON.stringify(area_list) );
					  return;
					}
				  
				  if ( evt.target.id === "Delete" ) {
					  map.graphics.remove(map.graphics.graphics[map.graphics.graphics.length - 1]);
					  area_list.splice(area_list.length-1,1);
					  area_list_WebMercator.splice(area_list_WebMercator.length-1,1);
					  console.log('Size of area array is ' + area_list.length);
					  console.log('Size of Mercator array is ' + area_list_WebMercator.length);
					  console.log( JSON.stringify(area_list) );
					  return;
					}
				  var tool = evt.target.id.toLowerCase();
				  map.disableMapNavigation();
				  tb.activate(tool);
				});
				initFunc(map);
			  }
			  
			  function initFunc(map) {
					if( navigator.geolocation ) {
						navigator.geolocation.getCurrentPosition(zoomToLocation, locationError);
						//watchId = navigator.geolocation.watchPosition(showLocation, locationError);
					} else {
						alert("Browser doesn't support Geolocation. Visit http://caniuse.com to see browser support for the Geolocation API.");
					}
				}
			
			function locationError(error) {

					//error occurred so stop watchPosition
					if( navigator.geolocation ) {
						navigator.geolocation.clearWatch(watchId);
					}
					switch (error.code) {
						case error.PERMISSION_DENIED:
							alert("Location not provided");
							break;

						case error.POSITION_UNAVAILABLE:
							alert("Current location not available");
							break;

						case error.TIMEOUT:
							alert("Timeout");
							break;

						default:
							alert("unknown error");
							break;
					}
				}
				
			function zoomToLocation(location) {
					console.log("Zoom");
					var pt = new Point(location.coords.longitude, location.coords.latitude);
					map.centerAndZoom(pt, 13);
				}

			  function addGraphic(evt) {
				//deactivate the toolbar and clear existing graphics 
				tb.deactivate(); 
				map.enableMapNavigation();

				// figure out which symbol to use
				var symbol;
				if ( evt.geometry.type === "point" || evt.geometry.type === "multipoint") {
				  symbol = markerSymbol;
				} else if ( evt.geometry.type === "line" || evt.geometry.type === "polyline") {
				  symbol = lineSymbol;
				}
				else {
				  symbol = fillSymbol;
				}
				
				var graphic_converted = webMercatorUtils.webMercatorToGeographic(evt.geometry);
				
				var newGraphic = new Graphic(evt.geometry, symbol);
				map.graphics.add(newGraphic);
				
				area_list.push(JSON.stringify(graphic_converted.toJson()));
				area_list_WebMercator.push(JSON.stringify(newGraphic.toJson()));				
				
				console.log('Size of area array is ' + area_list.length);   
				console.log( JSON.stringify(area_list) );
			  }
			});
	
		$("#save").click(function(){
		
			var taskName = $("#taskName").val();
			var taskDescription = $("#taskGeneralDescription").val();
			var taskCode = $("#taskCode").val(); 
			var taskPrice = $("#taskPrice").val(); 
			
			var startDate = $("#datepicker").val();
			var startHour = $("#startHour").val();
			var startMin  = $("#startMinute").val();
			
			var endDate = $("#datepicker2").val();
			var endHour = $("#endHour").val();
			var endMin  = $("#endMinute").val();
			
			var task = new Task(taskName,taskDescription,taskCode,taskPrice,
								startDate,startHour,startMin,
								endDate,endHour,endMin, area_list_WebMercator,area_list);
		
			$.post("saveTask.php",
				{ taskNamePost: 		taskName, 
				  taskConfig:			JSON.stringify(task)},
				function(data) {
			
					alert('Task insert ' + data);	
			});			
		});		
		
	});
	
	document.addEventListener("keydown", function(e){
        // USE THIS TO DISABLE CONTROL AND ALL FUNCTION KEYS
        // if (e.ctrlKey || (e.keyCode>=112 && e.keyCode<=123)) {
        // THIS WILL ONLY DISABLE CONTROL AND F12
        if (e.ctrlKey || e.keyCode==123) {
          e.stopPropagation();
          e.preventDefault();
        }
      });
	
	
	
	
	</script>
	
	
	


</head>

<body class="calcite">

<div id="left" class="main col-lg-5">
	
	<h2>Please specify the main parameters of a citizen science task</h2>
	<br>
	<table style="width:80%">	  
		  
		  <tr>   
		    <th>Name of task</th>
		    <th> <input type="text"        class = "form-control" name="demail" id="taskName"> </th>
		  </tr>
		  
		  <tr>
		    <th>General description of task</th>
		    <th> <textarea type="text" id="taskGeneralDescription"  class="form-control"style="width:70%;" rows="5" cols="60"></textarea> </th>
		  </tr>
		  
		  <tr>
		    <th>Task code</th>
		    <th> <input type="text"        class = "form-control" name="dcode" id="taskCode"> </th>
			
		  </tr>
		  
		  <tr>
		    <th>Task expected price</th>
		    <th> <input type="text"        class = "form-control" name="dPrice" id="taskPrice"> </th>
			
		  </tr>
	</table>
	
	
	<br><br>
	<div id="mycheckboxdiv"   >  
   <!-- Start Date: <input type="text" id="datepicker"><br> -->    
   <!-- End Date: <input type="text" id="datepicker2"> -->  
  
  <table>
  <tr> 
  		<th> Start date </th> 
  		<th> <input type="text" class = "form-control" id="datepicker"> </th>  
  </tr>
  <tr> 
  		<th> Start time (format hh:mm)</th> 
  		<th> <input type="text" id="startHour" size="1"> : <input type="text" id="startMinute" size="1">  </th>  
  </tr>
  <tr> 
  		<th> End date </th> 
  		<th> <input type="text" class = "form-control" id="datepicker2"> </th>  
  </tr> 
  <tr> 
  		<th> End time (format hh:mm) </th> 
  		<th> <input type="text" id="endHour" size="1"> : <input type="text"  id="endMinute" size="1">  </th>  
  </tr>
  
  </table>
  
  <style>
th, td {
    padding: 5px;
}
</style>
  
  </div>	
	<br><br>
	<input type="button" class="btn btn-primary" name="register" id="save" value="Save task">
	<input type="button" class="btn btn-danger" name="cancel" id="cancel" value="Cancel">	
	
</div>

<div id="right" class="col-lg-7 ">

<input type="checkbox" name="mycheckbox" id="geo" value="0" /> Tick to restrict the campaign to specific area(s) <br>

	<div id="info">
      <!-- <div>Select a shape then draw on map to add graphic</div> -->
      <p id="sentence1" style="margin-bottom: 0px;">Select a shape, </p>
      <p id="sentence2" style="margin-bottom: 0px;">then draw on the map. </p>
      <p id="sentence3" style="margin-bottom: 0px;"> Draw as many shapes </p>
	  <p id="sentence4"> as you like </p>
      <button id="Circle"     class="btn btn-block btn-success hiddenfirst" style="margin-bottom: -15px;" data-toggle="Circle-tooltip" title="Click on the desired center of the circle and drag to increase/decrease the radius. Release the mouse to finish the circle">Circle</button>      <br> 
      <button id="Polygon"    class="btn btn-block btn-success hiddenfirst" style="margin-bottom: -15px;" data-toggle="Polygon-tooltip" title="Click to specify the vertices of the polygon, double-click on the last vertices to complete and close the polygon">Polygon</button>      <br>
      
      <button id="Delete"     class="btn btn-block btn-warning hiddenfirst" style="margin-bottom: -15px;">Delete last shape</button> <br>     
      <button id="deleteall"  class="btn btn-block btn-danger  hiddenfirst" style="margin-bottom: -15px;">Delete All</button> <br>
      
    </div>

    <div id="mapDiv"></div>
	
	<div id="instructionCircle">To draw a circle, click on the center of your desired circle, hold the mouse and move to expand the circle, finally release mouse to finish the circle  </div>
	<div id="instructionPoligon">To draw a poligon, click to create the vertices of the poligon, finally double-click on the last vertex to close the poligon </div>

</div>
<br><br><br><br>

<!-- ------------------------------------------------------------------------------------------------ -->




</body>
</html>
